Attribute VB_Name = "CADDEBemassung"
Option Explicit


Public Sub DimChangeToM()
    
    Call DimChangeUnitAuswah(0.001)
    
End Sub

Public Sub DimChangeToCM()
    
    Call DimChangeUnitAuswah(0.1)
    
End Sub

Public Sub DimChangeToMM()
    
    Call DimChangeUnitAuswah(1)
    
End Sub

Public Sub DimChangeToM_H0()
    
    Call DimChangeUnitAuswah(0.001, True, False)
    
End Sub

Public Sub DimChangeToCM_H0()
    
    Call DimChangeUnitAuswah(0.1, True, False)
    
End Sub

Public Sub DimChangeToMM_H0()
    
    Call DimChangeUnitAuswah(1, True, False)
    
End Sub

Public Sub DimChangeToM_H5()
    
    Call DimChangeUnitAuswah(0.001, True, True)
    
End Sub

Public Sub DimChangeToCM_H5()
    
    Call DimChangeUnitAuswah(0.1, True, True)
End Sub

Public Sub DimChangeToMM_H5()
    
    Call DimChangeUnitAuswah(1, True, True)
    
End Sub

Public Sub DimChangeUnitAuswah(Optional Einheit As Double = 0.001, Optional Hochzahl As Boolean = False, Optional HochzahlRunden As Boolean = False)
    
    Dim SS As AcadSelectionSet
    Dim FldTypes(0 To 1) As Integer
    Dim FldValues(0 To 1) As Variant
    
    ' Filter erstellen
    FldTypes(0) = 0: FldValues(0) = "DIMENSION"
    FldTypes(1) = 100: FldValues(1) = "AcDbDimension"
    
    ' Selectionset bilden und befllen
    On Error Resume Next
    Set SS = ThisDrawing.SelectionSets("DimChangeUnitAuswahl")
    If Err Then Set SS = ThisDrawing.SelectionSets.Add("DimChangeUnitAuswahl")
    SS.Clear

    SS.SelectOnScreen FldTypes, FldValues
    
    If SS.Count = 0 Then GoTo ENDE

    Call DimChangeUnitExecute(SS, Einheit, Hochzahl, HochzahlRunden)
ENDE:
    SS.Delete
    
End Sub

'Feletic 03.06.2002
'ndert den Text einer Bemaung abhngig vom Mastab
'bergaben: SelectionSet mit Bemaungen
'           Einheit (Optional) --> 0.001=m, 0.1=cm, 1=mm
'           Hochzahl (Optional) --> Ja oder Nein
'           HochzahlRunden (Optional) --> Ja oder Nein; Ja --> auf 5-er gerundet
Public Sub DimChangeUnitExecute(SS As AcadSelectionSet, Optional Einheit As Double = 0.001, Optional Hochzahl As Boolean = False, Optional HochzahlRunden As Boolean = False)
    
    Dim Obj As AcadEntity               ' Bemaung
    Dim Verhaeltnis As Double           ' Verhltnis --> Einheit[0.001,0.1,1] / UFak[0.001,0.1.1]
    
    Dim HochzahlCheck As Boolean        ' Hochzahlen werden nur bei Bemaungstyp "DimAligned" und "DimRotated" geschrieben
    Dim BemText As String               ' Bemaungstext
    
    Dim varInsunits As Integer
    Dim UFAK As Double
    
    ' Ist das SelSet lehr, beenden wir die Funktion
    If SS.Count = 0 Then GoTo ENDE
    
    varInsunits = ThisDrawing.GetVariable("INSUNITS")
    
    Select Case varInsunits
        Case 4  ' =mm
            UFAK = 1
        Case 5  ' =cm
            UFAK = 0.1
        Case Else ' 6 = m
            UFAK = 0.001
    End Select
    
    Verhaeltnis = Einheit / UFAK
    
    For Each Obj In SS
        ' Abfrage, welches Objekt wir nun haben und ob wir Hochzahlen berhaupt zulassen
        Select Case TypeName(Obj)
            Case "IAcadDimRotated", "IAcadDimAligned"
                HochzahlCheck = Hochzahl
            Case Else
                HochzahlCheck = False
        End Select
        
        Select Case UFAK
            '~~~~~~~~~~~~~ Zeichnung in "m" ~~~~~~~~~~~~~~~
            Case 0.001
                Select Case Einheit
                
                    Case 0.001      ' Bemaung soll in "m" sein
                        If Format(Obj.Measurement / Obj.LinearScaleFactor, "0.00") < UFAK / Einheit Then
                        ' Bemaung <1.00 Einheiten
                            Obj.LinearScaleFactor = Verhaeltnis * 100
                            Obj.PrimaryUnitsPrecision = acDimPrecisionZero
                            Select Case HochzahlCheck
                                Case True
                                    If HochzahlRunden Then
                                        BemText = Format(funRunden(Obj.Measurement, 1, True), "0.0")
                                    Else
                                        BemText = Format(Obj.Measurement, "0.0")
                                    End If
                                    
                                    If Right(BemText, 1) <> "0" Then
                                        Obj.TextOverride = "\A1;" & Left(BemText, Len(BemText) - 2) & "{\H0.7x;\S" & Right(BemText, 1) & "^;}"
                                    Else
                                        Obj.TextOverride = ""
                                    End If
                                    
                                Case False
                                    Obj.TextOverride = ""
                            End Select
                        Else
                        ' Bemaung >1.00 Einheiten
                            Obj.LinearScaleFactor = Verhaeltnis
                            Obj.PrimaryUnitsPrecision = acDimPrecisionTwo
                            Obj.SuppressTrailingZeros = False
                            Obj.RoundDistance = 0.01
                            Select Case HochzahlCheck
                                Case True
                                    
                                    If HochzahlRunden Then
                                        BemText = Format(funRunden(Obj.Measurement, 3, True), "0.000")
                                    Else
                                        BemText = Format(Obj.Measurement, "0.000")
                                    End If
                                    
                                    If Right(BemText, 1) <> "0" Then
                                        Obj.TextOverride = "\A1;" & funPunkt(Left(BemText, Len(BemText) - 1)) & "{\H0.7x;\S" & Right(BemText, 1) & "^;}"
                                    Else
                                        Obj.TextOverride = ""
                                    End If
                                    
                                Case False
                                    Obj.TextOverride = ""
                            End Select
                        End If
                        
                    Case 0.1, 1     ' Bemaung soll in "cm" sein
                        Obj.LinearScaleFactor = Verhaeltnis
                        Obj.PrimaryUnitsPrecision = acDimPrecisionZero
                        
                        Select Case HochzahlCheck
                            Case True
                                
                                If HochzahlRunden Then
                                    BemText = Format(funRunden(Obj.Measurement, 1, True), "0.0")
                                Else
                                    BemText = Format(Obj.Measurement, "0.0")
                                End If
                               
                                If Right(BemText, 1) <> "0" Then
                                    Obj.TextOverride = "\A1;" & Left(BemText, Len(BemText) - 2) & "{\H0.7x;\S" & Right(BemText, 1) & "^;}"
                                Else
                                    Obj.TextOverride = ""
                                End If
                                
                            Case False
                                Obj.TextOverride = ""
                        End Select

                End Select
                
            '~~~~~~~~~~~~~ Zeichnung in "cm" ~~~~~~~~~~~~~~~
            Case 0.1
            
                Select Case Einheit
                
                    Case 0.001
                        If Format(Obj.Measurement / Obj.LinearScaleFactor, "0.00") < UFAK / Einheit Then
                            Obj.LinearScaleFactor = Verhaeltnis * 100
                            Obj.PrimaryUnitsPrecision = acDimPrecisionZero
                            
                            Select Case HochzahlCheck
                                Case True
                                
                                    If HochzahlRunden Then
                                        BemText = Format(funRunden(Obj.Measurement, 1, True), "0.0")
                                    Else
                                        BemText = Format(Obj.Measurement, "0.0")
                                    End If
                                   
                                    If Right(BemText, 1) <> "0" Then
                                        Obj.TextOverride = "\A1;" & Left(BemText, Len(BemText) - 2) & "{\H0.7x;\S" & Right(BemText, 1) & "^;}"
                                    Else
                                        Obj.TextOverride = ""
                                    End If
                                    
                                Case False
                                    Obj.TextOverride = ""
                            End Select
                        Else
                            Obj.LinearScaleFactor = Verhaeltnis
                            Obj.PrimaryUnitsPrecision = acDimPrecisionTwo
                            Obj.SuppressTrailingZeros = False
                            Obj.SuppressLeadingZeros = False
                            Obj.RoundDistance = 0.01
                            
                            Select Case HochzahlCheck
                                Case True
                                
                                    If HochzahlRunden Then
                                        BemText = Format(funRunden(Obj.Measurement, 3, True), "0.000")
                                    Else
                                        BemText = Format(Obj.Measurement, "0.000")
                                    End If
                                   
                                    If Right(BemText, 1) <> "0" Then
                                        Obj.TextOverride = "\A1;" & funPunkt(Left(BemText, Len(BemText) - 1)) & "{\H0.7x;\S" & Right(BemText, 1) & "^;}"
                                    Else
                                        Obj.TextOverride = ""
                                    End If
                                    
                                Case False
                                    Obj.TextOverride = ""
                            End Select
                            
                        End If
                        
                    Case 0.1, 1
                        Obj.LinearScaleFactor = Verhaeltnis
                        Obj.PrimaryUnitsPrecision = acDimPrecisionZero
                            
                        Select Case HochzahlCheck
                            Case True
                            
                                If HochzahlRunden Then
                                    BemText = Format(funRunden(Obj.Measurement, 1, True), "0.0")
                                Else
                                    BemText = Format(Obj.Measurement, "0.0")
                                End If
                               
                                If Right(BemText, 1) <> "0" Then
                                    Obj.TextOverride = "\A1;" & Left(BemText, Len(BemText) - 2) & "{\H0.7x;\S" & Right(BemText, 1) & "^;}"
                                Else
                                    Obj.TextOverride = ""
                                End If
                                
                            Case False
                                Obj.TextOverride = ""
                        End Select
                        
                End Select
            
            '~~~~~~~~~~~~~ Zeichnung in "mm" ~~~~~~~~~~~~~~~
            Case 1
                 Select Case Einheit
                    Case 0.001
                        If Format(Obj.Measurement / Obj.LinearScaleFactor, "0.000") < UFAK / Einheit Then
                            Obj.LinearScaleFactor = Verhaeltnis * 1000
                            Obj.PrimaryUnitsPrecision = acDimPrecisionZero
                            Select Case HochzahlCheck
                                Case True
                                   
                                    If HochzahlRunden Then
                                        BemText = Format(funRunden(Obj.Measurement, 1, True), "0.0")
                                    Else
                                        BemText = Format(Obj.Measurement, "0.0")
                                    End If
                                   
                                    If Right(BemText, 1) <> "0" Then
                                        Obj.TextOverride = "\A1;" & Left(BemText, Len(BemText) - 2) & "{\H0.7x;\S" & Right(BemText, 1) & "^;}"
                                    Else
                                        Obj.TextOverride = ""
                                    End If
                                    
                                Case False
                                    Obj.TextOverride = ""
                            End Select
                        Else
                            Obj.LinearScaleFactor = Verhaeltnis
                            Obj.PrimaryUnitsPrecision = acDimPrecisionThree
                            Obj.SuppressTrailingZeros = False
                            Obj.SuppressLeadingZeros = False
                            Obj.RoundDistance = 0.001
                            
                            Select Case HochzahlCheck
                                Case True
                                    
                                    If HochzahlRunden Then
                                        BemText = Format(funRunden(Obj.Measurement, 4, True), "0.0000")
                                    Else
                                        BemText = Format(Obj.Measurement, "0.0000")
                                    End If
                                   
                                    If Right(BemText, 1) <> "0" Then
                                        Obj.TextOverride = "\A1;" & funPunkt(Left(BemText, Len(BemText) - 1)) & "{\H0.7x;\S" & Right(BemText, 1) & "^;}"
                                    Else
                                        Obj.TextOverride = ""
                                    End If
                                    
                                Case False
                                    Obj.TextOverride = ""
                            End Select
                            
                        End If
                        
                    Case 0.1
                        Obj.LinearScaleFactor = Verhaeltnis
                        Obj.PrimaryUnitsPrecision = acDimPrecisionOne
                        Obj.SuppressTrailingZeros = True
                        Obj.RoundDistance = 0.1
                        
                        Select Case HochzahlCheck
                            Case True
                            
                                If HochzahlRunden Then
                                    BemText = Format(funRunden(Obj.Measurement, 2, True), "0.00")
                                Else
                                    BemText = Format(Obj.Measurement, "0.00")
                                End If
                               
                                If Right(BemText, 1) <> "0" Then
                                    Obj.TextOverride = "\A1;" & Left(BemText, Len(BemText) - 3) & "{\H0.7x;\S" & Right(BemText, 2) & "^;}"
                                Else
                                    Obj.TextOverride = ""
                                End If
                                
                            Case False
                                Obj.TextOverride = ""
                        End Select
                            
                    Case 1
                        Obj.LinearScaleFactor = Verhaeltnis
                        Obj.PrimaryUnitsPrecision = acDimPrecisionZero
                            Select Case HochzahlCheck
                                Case True
                                   
                                    If HochzahlRunden Then
                                        BemText = Format(funRunden(Obj.Measurement, 1, True), "0.0")
                                    Else
                                        BemText = Format(Obj.Measurement, "0.0")
                                    End If
                                   
                                    If Right(BemText, 1) <> "0" Then
                                        Obj.TextOverride = "\A1;" & Left(BemText, Len(BemText) - 2) & "{\H0.7x;\S" & Right(BemText, 1) & "^;}"
                                    Else
                                        Obj.TextOverride = ""
                                    End If
                                    
                                Case False
                                    Obj.TextOverride = ""
                            End Select
                
                End Select
        
        End Select
    Next Obj
    
ENDE:
    SS.Delete
    
End Sub

' Rundet den Wert auf Nachkommastellen
Public Function funRunden(Wert, Nachkomma, Optional Halbe As Boolean = False)
    
    Dim Uebertrag As Double
    
    If Halbe = False Then
        funRunden = Wert * (10 ^ Nachkomma) + 0.5
        funRunden = Int(funRunden) / (10 ^ Nachkomma)
    Else
        funRunden = Wert * (10 ^ (Nachkomma - 1))
        Select Case funRunden - Int(funRunden)
            Case Is < 0.25
                Uebertrag = 0
            Case Is < 0.75
                Uebertrag = 0.5
            Case Else
                Uebertrag = 1
        End Select
        funRunden = (Int(funRunden) + Uebertrag) / (10 ^ (Nachkomma - 1))
    End If
End Function

'Ersetzt Komma durch Punkt
Public Function funPunkt(Wert)
    Dim Punkt As Long
    Dim Komma As Long
    
    Wert = LTrim(Wert)
    Komma = InStr(Wert, ",")
    If Komma > 0 Then Mid(Wert, Komma) = "."
    Punkt = InStr(Wert, ".")
    If Punkt = 1 Then Wert = "0" & Wert
    
    funPunkt = Wert
End Function

